<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pygce.models.bot</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a href="https://github.com/sirfoga/pygce">PyGCE</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pygce-module.html">Package&nbsp;pygce</a> ::
        <a href="pygce.models-module.html">Package&nbsp;models</a> ::
        Module&nbsp;bot
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
        <tr><td align="right"><span class="options"
            >[<a href="frames.html" target="_top">frames</a
            >]&nbsp;|&nbsp;<a href="pygce.models.bot-pysrc.html"
            target="_top">no&nbsp;frames</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="pygce.models.bot-module.html">Module pygce.models.bot</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno">  1</tt>  <tt class="py-line"><tt class="py-comment"># !/usr/bin/python3</tt> </tt>
<a name="L2"></a><tt class="py-lineno">  2</tt>  <tt class="py-line"><tt class="py-comment"># coding: utf-8</tt> </tt>
<a name="L3"></a><tt class="py-lineno">  3</tt>  <tt class="py-line"> </tt>
<a name="L4"></a><tt class="py-lineno">  4</tt>  <tt class="py-line"><tt class="py-comment"># Copyright 2017 Stefano Fogarollo</tt> </tt>
<a name="L5"></a><tt class="py-lineno">  5</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L6"></a><tt class="py-lineno">  6</tt>  <tt class="py-line"><tt class="py-comment"># Licensed under the Apache License, Version 2.0 (the "License");</tt> </tt>
<a name="L7"></a><tt class="py-lineno">  7</tt>  <tt class="py-line"><tt class="py-comment"># you may not use this file except in compliance with the License.</tt> </tt>
<a name="L8"></a><tt class="py-lineno">  8</tt>  <tt class="py-line"><tt class="py-comment"># You may obtain a copy of the License at</tt> </tt>
<a name="L9"></a><tt class="py-lineno">  9</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L10"></a><tt class="py-lineno"> 10</tt>  <tt class="py-line"><tt class="py-comment"># http://www.apache.org/licenses/LICENSE-2.0</tt> </tt>
<a name="L11"></a><tt class="py-lineno"> 11</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L12"></a><tt class="py-lineno"> 12</tt>  <tt class="py-line"><tt class="py-comment"># Unless required by applicable law or agreed to in writing, software</tt> </tt>
<a name="L13"></a><tt class="py-lineno"> 13</tt>  <tt class="py-line"><tt class="py-comment"># distributed under the License is distributed on an "AS IS" BASIS,</tt> </tt>
<a name="L14"></a><tt class="py-lineno"> 14</tt>  <tt class="py-line"><tt class="py-comment"># WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</tt> </tt>
<a name="L15"></a><tt class="py-lineno"> 15</tt>  <tt class="py-line"><tt class="py-comment"># See the License for the specific language governing permissions and</tt> </tt>
<a name="L16"></a><tt class="py-lineno"> 16</tt>  <tt class="py-line"><tt class="py-comment"># limitations under the License.</tt> </tt>
<a name="L17"></a><tt class="py-lineno"> 17</tt>  <tt class="py-line"> </tt>
<a name="L18"></a><tt class="py-lineno"> 18</tt>  <tt class="py-line"> </tt>
<a name="L19"></a><tt class="py-lineno"> 19</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">csv</tt> </tt>
<a name="L20"></a><tt class="py-lineno"> 20</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">json</tt> </tt>
<a name="L21"></a><tt class="py-lineno"> 21</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt class="py-name">datetime</tt> <tt class="py-keyword">import</tt> <tt class="py-name">timedelta</tt> </tt>
<a name="L22"></a><tt class="py-lineno"> 22</tt>  <tt class="py-line"> </tt>
<a name="L23"></a><tt class="py-lineno"> 23</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt class="py-name">bs4</tt> <tt class="py-keyword">import</tt> <tt class="py-name">BeautifulSoup</tt> </tt>
<a name="L24"></a><tt class="py-lineno"> 24</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt class="py-name">hal</tt><tt class="py-op">.</tt><tt class="py-name">internet</tt><tt class="py-op">.</tt><tt class="py-name">selenium</tt> <tt class="py-keyword">import</tt> <tt class="py-name">SeleniumForm</tt> </tt>
<a name="L25"></a><tt class="py-lineno"> 25</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt class="py-name">selenium</tt> <tt class="py-keyword">import</tt> <tt class="py-name">webdriver</tt> </tt>
<a name="L26"></a><tt class="py-lineno"> 26</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt class="py-name">selenium</tt><tt class="py-op">.</tt><tt class="py-name">webdriver</tt><tt class="py-op">.</tt><tt class="py-name">common</tt><tt class="py-op">.</tt><tt class="py-name">by</tt> <tt class="py-keyword">import</tt> <tt class="py-name">By</tt> </tt>
<a name="L27"></a><tt class="py-lineno"> 27</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt class="py-name">selenium</tt><tt class="py-op">.</tt><tt class="py-name">webdriver</tt><tt class="py-op">.</tt><tt class="py-name">support</tt> <tt class="py-keyword">import</tt> <tt class="py-name">expected_conditions</tt> <tt class="py-keyword">as</tt> <tt class="py-name">EC</tt> </tt>
<a name="L28"></a><tt class="py-lineno"> 28</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt class="py-name">selenium</tt><tt class="py-op">.</tt><tt class="py-name">webdriver</tt><tt class="py-op">.</tt><tt class="py-name">support</tt><tt class="py-op">.</tt><tt class="py-name">ui</tt> <tt class="py-keyword">import</tt> <tt class="py-name">WebDriverWait</tt> </tt>
<a name="L29"></a><tt class="py-lineno"> 29</tt>  <tt class="py-line"> </tt>
<a name="L30"></a><tt class="py-lineno"> 30</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt class="py-op">.</tt><tt id="link-0" class="py-name" targets="Package pygce.models.garmin=pygce.models.garmin-module.html"><a title="pygce.models.garmin" class="py-name" href="#" onclick="return doclink('link-0', 'garmin', 'link-0');">garmin</a></tt><tt class="py-op">.</tt><tt id="link-1" class="py-name" targets="Module pygce.models.garmin.timeline=pygce.models.garmin.timeline-module.html"><a title="pygce.models.garmin.timeline" class="py-name" href="#" onclick="return doclink('link-1', 'timeline', 'link-1');">timeline</a></tt> <tt class="py-keyword">import</tt> <tt id="link-2" class="py-name" targets="Class pygce.models.garmin.timeline.GCDayTimeline=pygce.models.garmin.timeline.GCDayTimeline-class.html"><a title="pygce.models.garmin.timeline.GCDayTimeline" class="py-name" href="#" onclick="return doclink('link-2', 'GCDayTimeline', 'link-2');">GCDayTimeline</a></tt> </tt>
<a name="L31"></a><tt class="py-lineno"> 31</tt>  <tt class="py-line"> </tt>
<a name="L32"></a><tt class="py-lineno"> 32</tt>  <tt class="py-line"> </tt>
<a name="GarminConnectBot"></a><div id="GarminConnectBot-def"><a name="L33"></a><tt class="py-lineno"> 33</tt> <a class="py-toggle" href="#" id="GarminConnectBot-toggle" onclick="return toggle('GarminConnectBot');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pygce.models.bot.GarminConnectBot-class.html">GarminConnectBot</a><tt class="py-op">(</tt><tt class="py-base-class">object</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="GarminConnectBot-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="GarminConnectBot-expanded"><a name="L34"></a><tt class="py-lineno"> 34</tt>  <tt class="py-line">    <tt class="py-docstring">""" Navigate through Garmin Connect app via a bot """</tt> </tt>
<a name="L35"></a><tt class="py-lineno"> 35</tt>  <tt class="py-line"> </tt>
<a name="L36"></a><tt class="py-lineno"> 36</tt>  <tt class="py-line">    <tt id="link-3" class="py-name" targets="Variable pygce.models.bot.GarminConnectBot.USER_DASHBOARD=pygce.models.bot.GarminConnectBot-class.html#USER_DASHBOARD"><a title="pygce.models.bot.GarminConnectBot.USER_DASHBOARD" class="py-name" href="#" onclick="return doclink('link-3', 'USER_DASHBOARD', 'link-3');">USER_DASHBOARD</a></tt> <tt class="py-op">=</tt> <tt class="py-string">"https://connect.garmin.com/modern/"</tt> </tt>
<a name="L37"></a><tt class="py-lineno"> 37</tt>  <tt class="py-line">    <tt id="link-4" class="py-name" targets="Variable pygce.models.bot.GarminConnectBot.LOGIN_URL=pygce.models.bot.GarminConnectBot-class.html#LOGIN_URL"><a title="pygce.models.bot.GarminConnectBot.LOGIN_URL" class="py-name" href="#" onclick="return doclink('link-4', 'LOGIN_URL', 'link-4');">LOGIN_URL</a></tt> <tt class="py-op">=</tt> <tt class="py-string">"https://sso.garmin.com/sso/login?service=https%3A%2F%2Fconnect.garmin.com%2Fmodern%2F&amp;webhost=olaxpw-conctmodern005.garmin.com&amp;source=https%3A%2F%2Fconnect.garmin.com%2Fen-US%2Fsignin&amp;redirectAfterAccountLoginUrl=https%3A%2F%2Fconnect.garmin.com%2Fmodern%2F&amp;redirectAfterAccountCreationUrl=https%3A%2F%2Fconnect.garmin.com%2Fmodern%2F&amp;gauthHost=https%3A%2F%2Fsso.garmin.com%2Fsso&amp;locale=en_US&amp;id=gauth-widget&amp;clientId=GarminConnect&amp;initialFocus=true&amp;embedWidget=false&amp;mobile=false#"</tt> </tt>
<a name="L38"></a><tt class="py-lineno"> 38</tt>  <tt class="py-line">    <tt id="link-5" class="py-name" targets="Variable pygce.models.bot.GarminConnectBot.LOGIN_BUTTON_ID=pygce.models.bot.GarminConnectBot-class.html#LOGIN_BUTTON_ID"><a title="pygce.models.bot.GarminConnectBot.LOGIN_BUTTON_ID" class="py-name" href="#" onclick="return doclink('link-5', 'LOGIN_BUTTON_ID', 'link-5');">LOGIN_BUTTON_ID</a></tt> <tt class="py-op">=</tt> <tt class="py-string">"login-btn-signin"</tt>  <tt class="py-comment"># html id of the login button</tt> </tt>
<a name="L39"></a><tt class="py-lineno"> 39</tt>  <tt class="py-line">    <tt id="link-6" class="py-name" targets="Variable pygce.models.bot.GarminConnectBot.USERNAME_FIELD_NAME=pygce.models.bot.GarminConnectBot-class.html#USERNAME_FIELD_NAME"><a title="pygce.models.bot.GarminConnectBot.USERNAME_FIELD_NAME" class="py-name" href="#" onclick="return doclink('link-6', 'USERNAME_FIELD_NAME', 'link-6');">USERNAME_FIELD_NAME</a></tt> <tt class="py-op">=</tt> <tt class="py-string">"username"</tt>  <tt class="py-comment"># html name of username in login form</tt> </tt>
<a name="L40"></a><tt class="py-lineno"> 40</tt>  <tt class="py-line">    <tt id="link-7" class="py-name" targets="Variable pygce.models.bot.GarminConnectBot.PASSWORD_FIELD_NAME=pygce.models.bot.GarminConnectBot-class.html#PASSWORD_FIELD_NAME"><a title="pygce.models.bot.GarminConnectBot.PASSWORD_FIELD_NAME" class="py-name" href="#" onclick="return doclink('link-7', 'PASSWORD_FIELD_NAME', 'link-7');">PASSWORD_FIELD_NAME</a></tt> <tt class="py-op">=</tt> <tt class="py-string">"password"</tt>  <tt class="py-comment"># html name of password in login form</tt> </tt>
<a name="L41"></a><tt class="py-lineno"> 41</tt>  <tt class="py-line">    <tt id="link-8" class="py-name" targets="Variable pygce.models.bot.GarminConnectBot.BROWSER_WAIT_TIMEOUT_SECONDS=pygce.models.bot.GarminConnectBot-class.html#BROWSER_WAIT_TIMEOUT_SECONDS"><a title="pygce.models.bot.GarminConnectBot.BROWSER_WAIT_TIMEOUT_SECONDS" class="py-name" href="#" onclick="return doclink('link-8', 'BROWSER_WAIT_TIMEOUT_SECONDS', 'link-8');">BROWSER_WAIT_TIMEOUT_SECONDS</a></tt> <tt class="py-op">=</tt> <tt class="py-number">5</tt>  <tt class="py-comment"># max seconds before url request is discarded</tt> </tt>
<a name="L42"></a><tt class="py-lineno"> 42</tt>  <tt class="py-line"> </tt>
<a name="GarminConnectBot.__init__"></a><div id="GarminConnectBot.__init__-def"><a name="L43"></a><tt class="py-lineno"> 43</tt> <a class="py-toggle" href="#" id="GarminConnectBot.__init__-toggle" onclick="return toggle('GarminConnectBot.__init__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pygce.models.bot.GarminConnectBot-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">user_name</tt><tt class="py-op">,</tt> <tt class="py-param">password</tt><tt class="py-op">,</tt> <tt class="py-param">chromedriver_path</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="GarminConnectBot.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="GarminConnectBot.__init__-expanded"><a name="L44"></a><tt class="py-lineno"> 44</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L45"></a><tt class="py-lineno"> 45</tt>  <tt class="py-line"><tt class="py-docstring">        :param user_name: str</tt> </tt>
<a name="L46"></a><tt class="py-lineno"> 46</tt>  <tt class="py-line"><tt class="py-docstring">            Username (email) to login to Garmin Connect</tt> </tt>
<a name="L47"></a><tt class="py-lineno"> 47</tt>  <tt class="py-line"><tt class="py-docstring">        :param password: str</tt> </tt>
<a name="L48"></a><tt class="py-lineno"> 48</tt>  <tt class="py-line"><tt class="py-docstring">            Password to login to Garmin Connect</tt> </tt>
<a name="L49"></a><tt class="py-lineno"> 49</tt>  <tt class="py-line"><tt class="py-docstring">        :param chromedriver_path: str</tt> </tt>
<a name="L50"></a><tt class="py-lineno"> 50</tt>  <tt class="py-line"><tt class="py-docstring">            Path to Chrome driver to use as browser</tt> </tt>
<a name="L51"></a><tt class="py-lineno"> 51</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L52"></a><tt class="py-lineno"> 52</tt>  <tt class="py-line"> </tt>
<a name="L53"></a><tt class="py-lineno"> 53</tt>  <tt class="py-line">        <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-9" class="py-name" targets="Method pygce.analysis.models.ActivitiesDataAnalysis.__init__()=pygce.analysis.models.ActivitiesDataAnalysis-class.html#__init__,Method pygce.analysis.models.GarminDataFilter.__init__()=pygce.analysis.models.GarminDataFilter-class.html#__init__,Method pygce.analysis.models.MLAnalysis.__init__()=pygce.analysis.models.MLAnalysis-class.html#__init__,Method pygce.analysis.models.StatsAnalysis.__init__()=pygce.analysis.models.StatsAnalysis-class.html#__init__,Method pygce.analysis.models.TimelineDataAnalysis.__init__()=pygce.analysis.models.TimelineDataAnalysis-class.html#__init__,Method pygce.models.bot.GarminConnectBot.__init__()=pygce.models.bot.GarminConnectBot-class.html#__init__,Method pygce.models.garmin.timeline.GCDayActivities.__init__()=pygce.models.garmin.timeline.GCDayActivities-class.html#__init__,Method pygce.models.garmin.timeline.GCDayBreakdown.__init__()=pygce.models.garmin.timeline.GCDayBreakdown-class.html#__init__,Method pygce.models.garmin.timeline.GCDaySection.__init__()=pygce.models.garmin.timeline.GCDaySection-class.html#__init__,Method pygce.models.garmin.timeline.GCDaySleep.__init__()=pygce.models.garmin.timeline.GCDaySleep-class.html#__init__,Method pygce.models.garmin.timeline.GCDaySteps.__init__()=pygce.models.garmin.timeline.GCDaySteps-class.html#__init__,Method pygce.models.garmin.timeline.GCDaySummary.__init__()=pygce.models.garmin.timeline.GCDaySummary-class.html#__init__,Method pygce.models.garmin.timeline.GCDayTimeline.__init__()=pygce.models.garmin.timeline.GCDayTimeline-class.html#__init__"><a title="pygce.analysis.models.ActivitiesDataAnalysis.__init__
pygce.analysis.models.GarminDataFilter.__init__
pygce.analysis.models.MLAnalysis.__init__
pygce.analysis.models.StatsAnalysis.__init__
pygce.analysis.models.TimelineDataAnalysis.__init__
pygce.models.bot.GarminConnectBot.__init__
pygce.models.garmin.timeline.GCDayActivities.__init__
pygce.models.garmin.timeline.GCDayBreakdown.__init__
pygce.models.garmin.timeline.GCDaySection.__init__
pygce.models.garmin.timeline.GCDaySleep.__init__
pygce.models.garmin.timeline.GCDaySteps.__init__
pygce.models.garmin.timeline.GCDaySummary.__init__
pygce.models.garmin.timeline.GCDayTimeline.__init__" class="py-name" href="#" onclick="return doclink('link-9', '__init__', 'link-9');">__init__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">)</tt> </tt>
<a name="L54"></a><tt class="py-lineno"> 54</tt>  <tt class="py-line"> </tt>
<a name="L55"></a><tt class="py-lineno"> 55</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">browser</tt> <tt class="py-op">=</tt> <tt class="py-name">webdriver</tt><tt class="py-op">.</tt><tt class="py-name">Chrome</tt><tt class="py-op">(</tt><tt class="py-name">chromedriver_path</tt><tt class="py-op">)</tt>  <tt class="py-comment"># bot browser to use</tt> </tt>
<a name="L56"></a><tt class="py-lineno"> 56</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_name</tt> <tt class="py-op">=</tt> <tt class="py-name">user_name</tt>  <tt class="py-comment"># user settings</tt> </tt>
<a name="L57"></a><tt class="py-lineno"> 57</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_password</tt> <tt class="py-op">=</tt> <tt class="py-name">password</tt> </tt>
<a name="L58"></a><tt class="py-lineno"> 58</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_logged_in</tt> <tt class="py-op">=</tt> <tt class="py-name">False</tt>  <tt class="py-comment"># True iff user is correctly logged in</tt> </tt>
<a name="L59"></a><tt class="py-lineno"> 59</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_id</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt>  <tt class="py-comment"># id of user logged in</tt> </tt>
</div><a name="L60"></a><tt class="py-lineno"> 60</tt>  <tt class="py-line"> </tt>
<a name="GarminConnectBot.login"></a><div id="GarminConnectBot.login-def"><a name="L61"></a><tt class="py-lineno"> 61</tt> <a class="py-toggle" href="#" id="GarminConnectBot.login-toggle" onclick="return toggle('GarminConnectBot.login');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pygce.models.bot.GarminConnectBot-class.html#login">login</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="GarminConnectBot.login-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="GarminConnectBot.login-expanded"><a name="L62"></a><tt class="py-lineno"> 62</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L63"></a><tt class="py-lineno"> 63</tt>  <tt class="py-line"><tt class="py-docstring">        :return: bool</tt> </tt>
<a name="L64"></a><tt class="py-lineno"> 64</tt>  <tt class="py-line"><tt class="py-docstring">            True iff correctly logged in</tt> </tt>
<a name="L65"></a><tt class="py-lineno"> 65</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L66"></a><tt class="py-lineno"> 66</tt>  <tt class="py-line"> </tt>
<a name="L67"></a><tt class="py-lineno"> 67</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L68"></a><tt class="py-lineno"> 68</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">browser</tt><tt class="py-op">.</tt><tt class="py-name">get</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-10" class="py-name"><a title="pygce.models.bot.GarminConnectBot.LOGIN_URL" class="py-name" href="#" onclick="return doclink('link-10', 'LOGIN_URL', 'link-4');">LOGIN_URL</a></tt><tt class="py-op">)</tt>  <tt class="py-comment"># open login url</tt> </tt>
<a name="L69"></a><tt class="py-lineno"> 69</tt>  <tt class="py-line">            <tt class="py-name">SeleniumForm</tt><tt class="py-op">.</tt><tt class="py-name">fill_login_form</tt><tt class="py-op">(</tt> </tt>
<a name="L70"></a><tt class="py-lineno"> 70</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">browser</tt><tt class="py-op">,</tt> </tt>
<a name="L71"></a><tt class="py-lineno"> 71</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_name</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-11" class="py-name"><a title="pygce.models.bot.GarminConnectBot.USERNAME_FIELD_NAME" class="py-name" href="#" onclick="return doclink('link-11', 'USERNAME_FIELD_NAME', 'link-6');">USERNAME_FIELD_NAME</a></tt><tt class="py-op">,</tt> </tt>
<a name="L72"></a><tt class="py-lineno"> 72</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_password</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-12" class="py-name"><a title="pygce.models.bot.GarminConnectBot.PASSWORD_FIELD_NAME" class="py-name" href="#" onclick="return doclink('link-12', 'PASSWORD_FIELD_NAME', 'link-7');">PASSWORD_FIELD_NAME</a></tt> </tt>
<a name="L73"></a><tt class="py-lineno"> 73</tt>  <tt class="py-line">            <tt class="py-op">)</tt>  <tt class="py-comment"># fill login form</tt> </tt>
<a name="L74"></a><tt class="py-lineno"> 74</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">browser</tt><tt class="py-op">.</tt><tt class="py-name">execute_script</tt><tt class="py-op">(</tt> </tt>
<a name="L75"></a><tt class="py-lineno"> 75</tt>  <tt class="py-line">                <tt class="py-string">"document.getElementById(\""</tt> <tt class="py-op">+</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-13" class="py-name"><a title="pygce.models.bot.GarminConnectBot.LOGIN_BUTTON_ID" class="py-name" href="#" onclick="return doclink('link-13', 'LOGIN_BUTTON_ID', 'link-5');">LOGIN_BUTTON_ID</a></tt> <tt class="py-op">+</tt> <tt class="py-string">"\").click()"</tt><tt class="py-op">)</tt>  <tt class="py-comment"># click button to login</tt> </tt>
<a name="L76"></a><tt class="py-lineno"> 76</tt>  <tt class="py-line">            <tt class="py-name">WebDriverWait</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">browser</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-14" class="py-name"><a title="pygce.models.bot.GarminConnectBot.BROWSER_WAIT_TIMEOUT_SECONDS" class="py-name" href="#" onclick="return doclink('link-14', 'BROWSER_WAIT_TIMEOUT_SECONDS', 'link-8');">BROWSER_WAIT_TIMEOUT_SECONDS</a></tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">until</tt><tt class="py-op">(</tt> </tt>
<a name="L77"></a><tt class="py-lineno"> 77</tt>  <tt class="py-line">                <tt class="py-name">EC</tt><tt class="py-op">.</tt><tt class="py-name">presence_of_element_located</tt><tt class="py-op">(</tt><tt class="py-op">(</tt><tt class="py-name">By</tt><tt class="py-op">.</tt><tt class="py-name">CLASS_NAME</tt><tt class="py-op">,</tt> <tt class="py-string">"activity-tracking-disclaimer"</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L78"></a><tt class="py-lineno"> 78</tt>  <tt class="py-line">            <tt class="py-op">)</tt>  <tt class="py-comment"># wait until fully loaded</tt> </tt>
<a name="L79"></a><tt class="py-lineno"> 79</tt>  <tt class="py-line"> </tt>
<a name="L80"></a><tt class="py-lineno"> 80</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_logged_in</tt> <tt class="py-op">=</tt> <tt class="py-name">True</tt> </tt>
<a name="L81"></a><tt class="py-lineno"> 81</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">True</tt>  <tt class="py-comment"># if arrived here, everything is fine</tt> </tt>
<a name="L82"></a><tt class="py-lineno"> 82</tt>  <tt class="py-line">        <tt class="py-keyword">except</tt> <tt class="py-name">Exception</tt> <tt class="py-keyword">as</tt> <tt class="py-name">e</tt><tt class="py-op">:</tt> </tt>
<a name="L83"></a><tt class="py-lineno"> 83</tt>  <tt class="py-line">            <tt class="py-keyword">print</tt><tt class="py-op">(</tt><tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">e</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L84"></a><tt class="py-lineno"> 84</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_logged_in</tt> <tt class="py-op">=</tt> <tt class="py-name">False</tt> </tt>
<a name="L85"></a><tt class="py-lineno"> 85</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">False</tt>  <tt class="py-comment"># something went wrong</tt> </tt>
</div><a name="L86"></a><tt class="py-lineno"> 86</tt>  <tt class="py-line"> </tt>
<a name="GarminConnectBot.get_user_id"></a><div id="GarminConnectBot.get_user_id-def"><a name="L87"></a><tt class="py-lineno"> 87</tt> <a class="py-toggle" href="#" id="GarminConnectBot.get_user_id-toggle" onclick="return toggle('GarminConnectBot.get_user_id');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pygce.models.bot.GarminConnectBot-class.html#get_user_id">get_user_id</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="GarminConnectBot.get_user_id-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="GarminConnectBot.get_user_id-expanded"><a name="L88"></a><tt class="py-lineno"> 88</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L89"></a><tt class="py-lineno"> 89</tt>  <tt class="py-line"><tt class="py-docstring">        :return: void</tt> </tt>
<a name="L90"></a><tt class="py-lineno"> 90</tt>  <tt class="py-line"><tt class="py-docstring">            Retrieves user unique id and token</tt> </tt>
<a name="L91"></a><tt class="py-lineno"> 91</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L92"></a><tt class="py-lineno"> 92</tt>  <tt class="py-line"> </tt>
<a name="L93"></a><tt class="py-lineno"> 93</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_id</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L94"></a><tt class="py-lineno"> 94</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-15" class="py-name" targets="Method pygce.models.bot.GarminConnectBot.go_to_dashboard()=pygce.models.bot.GarminConnectBot-class.html#go_to_dashboard"><a title="pygce.models.bot.GarminConnectBot.go_to_dashboard" class="py-name" href="#" onclick="return doclink('link-15', 'go_to_dashboard', 'link-15');">go_to_dashboard</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L95"></a><tt class="py-lineno"> 95</tt>  <tt class="py-line">            <tt class="py-name">soup</tt> <tt class="py-op">=</tt> <tt class="py-name">BeautifulSoup</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">browser</tt><tt class="py-op">.</tt><tt class="py-name">page_source</tt><tt class="py-op">,</tt> <tt class="py-string">"lxml"</tt><tt class="py-op">)</tt>  <tt class="py-comment"># html parser</tt> </tt>
<a name="L96"></a><tt class="py-lineno"> 96</tt>  <tt class="py-line">            <tt class="py-name">widgets</tt> <tt class="py-op">=</tt> <tt class="py-name">soup</tt><tt class="py-op">.</tt><tt class="py-name">find_all</tt><tt class="py-op">(</tt><tt class="py-string">"div"</tt><tt class="py-op">,</tt> <tt class="py-op">{</tt><tt class="py-string">"class"</tt><tt class="py-op">:</tt> <tt class="py-string">"widget-content"</tt><tt class="py-op">}</tt><tt class="py-op">)</tt> </tt>
<a name="L97"></a><tt class="py-lineno"> 97</tt>  <tt class="py-line"> </tt>
<a name="L98"></a><tt class="py-lineno"> 98</tt>  <tt class="py-line">            <tt class="py-name">id_found</tt> <tt class="py-op">=</tt> <tt class="py-name">False</tt>  <tt class="py-comment"># True iff id has been found</tt> </tt>
<a name="L99"></a><tt class="py-lineno"> 99</tt>  <tt class="py-line">            <tt class="py-keyword">for</tt> <tt class="py-name">w</tt> <tt class="py-keyword">in</tt> <tt class="py-name">widgets</tt><tt class="py-op">:</tt> </tt>
<a name="L100"></a><tt class="py-lineno">100</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">id_found</tt><tt class="py-op">:</tt> </tt>
<a name="L101"></a><tt class="py-lineno">101</tt>  <tt class="py-line">                    <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L102"></a><tt class="py-lineno">102</tt>  <tt class="py-line">                        <tt class="py-name">widget_title</tt> <tt class="py-op">=</tt> <tt class="py-name">w</tt><tt class="py-op">.</tt><tt class="py-name">find_all</tt><tt class="py-op">(</tt><tt class="py-string">"h3"</tt><tt class="py-op">,</tt> <tt class="py-op">{</tt><tt class="py-string">"class"</tt><tt class="py-op">:</tt> <tt class="py-string">"data-bit"</tt><tt class="py-op">}</tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L103"></a><tt class="py-lineno">103</tt>  <tt class="py-line">                        <tt class="py-name">raw_id</tt> <tt class="py-op">=</tt> <tt class="py-name">widget_title</tt><tt class="py-op">.</tt><tt class="py-name">a</tt><tt class="py-op">[</tt><tt class="py-string">"href"</tt><tt class="py-op">]</tt> </tt>
<a name="L104"></a><tt class="py-lineno">104</tt>  <tt class="py-line">                        <tt class="py-name">tokens</tt> <tt class="py-op">=</tt> <tt class="py-name">raw_id</tt><tt class="py-op">.</tt><tt class="py-name">split</tt><tt class="py-op">(</tt><tt class="py-string">"/"</tt><tt class="py-op">)</tt> </tt>
<a name="L105"></a><tt class="py-lineno">105</tt>  <tt class="py-line">                        <tt class="py-name">candidate_id</tt> <tt class="py-op">=</tt> <tt class="py-name">max</tt><tt class="py-op">(</tt><tt class="py-name">tokens</tt><tt class="py-op">,</tt> <tt class="py-name">key</tt><tt class="py-op">=</tt><tt class="py-name">len</tt><tt class="py-op">)</tt>  <tt class="py-comment"># longest string (typically is the id, since it's 36 chars)</tt> </tt>
<a name="L106"></a><tt class="py-lineno">106</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_id</tt> <tt class="py-op">=</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">candidate_id</tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">strip</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L107"></a><tt class="py-lineno">107</tt>  <tt class="py-line">                        <tt class="py-name">id_found</tt> <tt class="py-op">=</tt> <tt class="py-name">True</tt> </tt>
<a name="L108"></a><tt class="py-lineno">108</tt>  <tt class="py-line">                    <tt class="py-keyword">except</tt><tt class="py-op">:</tt> </tt>
<a name="L109"></a><tt class="py-lineno">109</tt>  <tt class="py-line">                        <tt class="py-keyword">pass</tt>  <tt class="py-comment"># that widget didn't contain the id .. skip to the next</tt> </tt>
</div><a name="L110"></a><tt class="py-lineno">110</tt>  <tt class="py-line"> </tt>
<a name="GarminConnectBot.go_to_dashboard"></a><div id="GarminConnectBot.go_to_dashboard-def"><a name="L111"></a><tt class="py-lineno">111</tt> <a class="py-toggle" href="#" id="GarminConnectBot.go_to_dashboard-toggle" onclick="return toggle('GarminConnectBot.go_to_dashboard');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pygce.models.bot.GarminConnectBot-class.html#go_to_dashboard">go_to_dashboard</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="GarminConnectBot.go_to_dashboard-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="GarminConnectBot.go_to_dashboard-expanded"><a name="L112"></a><tt class="py-lineno">112</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L113"></a><tt class="py-lineno">113</tt>  <tt class="py-line"><tt class="py-docstring">        :return: void</tt> </tt>
<a name="L114"></a><tt class="py-lineno">114</tt>  <tt class="py-line"><tt class="py-docstring">            Navigates to user homepage</tt> </tt>
<a name="L115"></a><tt class="py-lineno">115</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L116"></a><tt class="py-lineno">116</tt>  <tt class="py-line"> </tt>
<a name="L117"></a><tt class="py-lineno">117</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_logged_in</tt><tt class="py-op">:</tt> </tt>
<a name="L118"></a><tt class="py-lineno">118</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-16" class="py-name" targets="Method pygce.models.bot.GarminConnectBot.login()=pygce.models.bot.GarminConnectBot-class.html#login"><a title="pygce.models.bot.GarminConnectBot.login" class="py-name" href="#" onclick="return doclink('link-16', 'login', 'link-16');">login</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L119"></a><tt class="py-lineno">119</tt>  <tt class="py-line"> </tt>
<a name="L120"></a><tt class="py-lineno">120</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">browser</tt><tt class="py-op">.</tt><tt class="py-name">get</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-17" class="py-name"><a title="pygce.models.bot.GarminConnectBot.USER_DASHBOARD" class="py-name" href="#" onclick="return doclink('link-17', 'USER_DASHBOARD', 'link-3');">USER_DASHBOARD</a></tt><tt class="py-op">)</tt> </tt>
<a name="L121"></a><tt class="py-lineno">121</tt>  <tt class="py-line">        <tt class="py-name">WebDriverWait</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">browser</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-18" class="py-name"><a title="pygce.models.bot.GarminConnectBot.BROWSER_WAIT_TIMEOUT_SECONDS" class="py-name" href="#" onclick="return doclink('link-18', 'BROWSER_WAIT_TIMEOUT_SECONDS', 'link-8');">BROWSER_WAIT_TIMEOUT_SECONDS</a></tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">until</tt><tt class="py-op">(</tt> </tt>
<a name="L122"></a><tt class="py-lineno">122</tt>  <tt class="py-line">            <tt class="py-name">EC</tt><tt class="py-op">.</tt><tt class="py-name">presence_of_element_located</tt><tt class="py-op">(</tt><tt class="py-op">(</tt><tt class="py-name">By</tt><tt class="py-op">.</tt><tt class="py-name">CLASS_NAME</tt><tt class="py-op">,</tt> <tt class="py-string">"widget-content"</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L123"></a><tt class="py-lineno">123</tt>  <tt class="py-line">        <tt class="py-op">)</tt>  <tt class="py-comment"># wait until fully loaded</tt> </tt>
</div><a name="L124"></a><tt class="py-lineno">124</tt>  <tt class="py-line"> </tt>
<a name="GarminConnectBot.go_to_day"></a><div id="GarminConnectBot.go_to_day-def"><a name="L125"></a><tt class="py-lineno">125</tt> <a class="py-toggle" href="#" id="GarminConnectBot.go_to_day-toggle" onclick="return toggle('GarminConnectBot.go_to_day');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pygce.models.bot.GarminConnectBot-class.html#go_to_day">go_to_day</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">date_time</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="GarminConnectBot.go_to_day-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="GarminConnectBot.go_to_day-expanded"><a name="L126"></a><tt class="py-lineno">126</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L127"></a><tt class="py-lineno">127</tt>  <tt class="py-line"><tt class="py-docstring">        :param date_time: datetime</tt> </tt>
<a name="L128"></a><tt class="py-lineno">128</tt>  <tt class="py-line"><tt class="py-docstring">            Datetime object with date</tt> </tt>
<a name="L129"></a><tt class="py-lineno">129</tt>  <tt class="py-line"><tt class="py-docstring">        :return: void</tt> </tt>
<a name="L130"></a><tt class="py-lineno">130</tt>  <tt class="py-line"><tt class="py-docstring">            Navigates to daily summary of given date</tt> </tt>
<a name="L131"></a><tt class="py-lineno">131</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L132"></a><tt class="py-lineno">132</tt>  <tt class="py-line"> </tt>
<a name="L133"></a><tt class="py-lineno">133</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_id</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L134"></a><tt class="py-lineno">134</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-19" class="py-name" targets="Method pygce.models.bot.GarminConnectBot.get_user_id()=pygce.models.bot.GarminConnectBot-class.html#get_user_id"><a title="pygce.models.bot.GarminConnectBot.get_user_id" class="py-name" href="#" onclick="return doclink('link-19', 'get_user_id', 'link-19');">get_user_id</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L135"></a><tt class="py-lineno">135</tt>  <tt class="py-line"> </tt>
<a name="L136"></a><tt class="py-lineno">136</tt>  <tt class="py-line">        <tt class="py-name">date_to_to</tt> <tt class="py-op">=</tt> <tt class="py-name">date_time</tt><tt class="py-op">.</tt><tt class="py-name">strftime</tt><tt class="py-op">(</tt><tt class="py-string">'%Y-%m-%d'</tt><tt class="py-op">)</tt>  <tt class="py-comment"># retrieve year, month and day to to go to</tt> </tt>
<a name="L137"></a><tt class="py-lineno">137</tt>  <tt class="py-line">        <tt class="py-name">url_to_get</tt> <tt class="py-op">=</tt> <tt class="py-string">"https://connect.garmin.com/modern/daily-summary/"</tt> <tt class="py-op">+</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">user_id</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-string">"/"</tt> <tt class="py-op">+</tt> <tt class="py-name">date_to_to</tt> </tt>
<a name="L138"></a><tt class="py-lineno">138</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">browser</tt><tt class="py-op">.</tt><tt class="py-name">get</tt><tt class="py-op">(</tt><tt class="py-name">url_to_get</tt><tt class="py-op">)</tt> </tt>
<a name="L139"></a><tt class="py-lineno">139</tt>  <tt class="py-line">        <tt class="py-name">WebDriverWait</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">browser</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-20" class="py-name"><a title="pygce.models.bot.GarminConnectBot.BROWSER_WAIT_TIMEOUT_SECONDS" class="py-name" href="#" onclick="return doclink('link-20', 'BROWSER_WAIT_TIMEOUT_SECONDS', 'link-8');">BROWSER_WAIT_TIMEOUT_SECONDS</a></tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">until</tt><tt class="py-op">(</tt> </tt>
<a name="L140"></a><tt class="py-lineno">140</tt>  <tt class="py-line">            <tt class="py-name">EC</tt><tt class="py-op">.</tt><tt class="py-name">presence_of_element_located</tt><tt class="py-op">(</tt><tt class="py-op">(</tt><tt class="py-name">By</tt><tt class="py-op">.</tt><tt class="py-name">CLASS_NAME</tt><tt class="py-op">,</tt> <tt class="py-string">"comment-container"</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L141"></a><tt class="py-lineno">141</tt>  <tt class="py-line">        <tt class="py-op">)</tt>  <tt class="py-comment"># wait until fully loaded</tt> </tt>
</div><a name="L142"></a><tt class="py-lineno">142</tt>  <tt class="py-line"> </tt>
<a name="GarminConnectBot.get_day"></a><div id="GarminConnectBot.get_day-def"><a name="L143"></a><tt class="py-lineno">143</tt> <a class="py-toggle" href="#" id="GarminConnectBot.get_day-toggle" onclick="return toggle('GarminConnectBot.get_day');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pygce.models.bot.GarminConnectBot-class.html#get_day">get_day</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">date_time</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="GarminConnectBot.get_day-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="GarminConnectBot.get_day-expanded"><a name="L144"></a><tt class="py-lineno">144</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L145"></a><tt class="py-lineno">145</tt>  <tt class="py-line"><tt class="py-docstring">        :param date_time: datetime</tt> </tt>
<a name="L146"></a><tt class="py-lineno">146</tt>  <tt class="py-line"><tt class="py-docstring">            Datetime object with date</tt> </tt>
<a name="L147"></a><tt class="py-lineno">147</tt>  <tt class="py-line"><tt class="py-docstring">        :return: GCDayTimline</tt> </tt>
<a name="L148"></a><tt class="py-lineno">148</tt>  <tt class="py-line"><tt class="py-docstring">            Data about day</tt> </tt>
<a name="L149"></a><tt class="py-lineno">149</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L150"></a><tt class="py-lineno">150</tt>  <tt class="py-line"> </tt>
<a name="L151"></a><tt class="py-lineno">151</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L152"></a><tt class="py-lineno">152</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-21" class="py-name" targets="Method pygce.models.bot.GarminConnectBot.go_to_day()=pygce.models.bot.GarminConnectBot-class.html#go_to_day"><a title="pygce.models.bot.GarminConnectBot.go_to_day" class="py-name" href="#" onclick="return doclink('link-21', 'go_to_day', 'link-21');">go_to_day</a></tt><tt class="py-op">(</tt><tt class="py-name">date_time</tt><tt class="py-op">)</tt> </tt>
<a name="L153"></a><tt class="py-lineno">153</tt>  <tt class="py-line">            <tt class="py-name">soup</tt> <tt class="py-op">=</tt> <tt class="py-name">BeautifulSoup</tt><tt class="py-op">(</tt><tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">browser</tt><tt class="py-op">.</tt><tt class="py-name">page_source</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> <tt class="py-string">"html.parser"</tt><tt class="py-op">)</tt>  <tt class="py-comment"># html parser</tt> </tt>
<a name="L154"></a><tt class="py-lineno">154</tt>  <tt class="py-line"> </tt>
<a name="L155"></a><tt class="py-lineno">155</tt>  <tt class="py-line">            <tt class="py-name">tabs_html</tt> <tt class="py-op">=</tt> <tt class="py-name">soup</tt><tt class="py-op">.</tt><tt class="py-name">find_all</tt><tt class="py-op">(</tt><tt class="py-string">"div"</tt><tt class="py-op">,</tt> <tt class="py-op">{</tt><tt class="py-string">"class"</tt><tt class="py-op">:</tt> <tt class="py-string">"tab-content"</tt><tt class="py-op">}</tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt>  <tt class="py-comment"># find html source code for sections</tt> </tt>
<a name="L156"></a><tt class="py-lineno">156</tt>  <tt class="py-line">            <tt class="py-name">summary_html</tt> <tt class="py-op">=</tt> <tt class="py-name">soup</tt><tt class="py-op">.</tt><tt class="py-name">find_all</tt><tt class="py-op">(</tt><tt class="py-string">"div"</tt><tt class="py-op">,</tt> <tt class="py-op">{</tt><tt class="py-string">"class"</tt><tt class="py-op">:</tt> <tt class="py-string">"content page steps sleep calories timeline"</tt><tt class="py-op">}</tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L157"></a><tt class="py-lineno">157</tt>  <tt class="py-line">            <tt class="py-name">steps_html</tt> <tt class="py-op">=</tt> <tt class="py-name">soup</tt><tt class="py-op">.</tt><tt class="py-name">find_all</tt><tt class="py-op">(</tt><tt class="py-string">"div"</tt><tt class="py-op">,</tt> <tt class="py-op">{</tt><tt class="py-string">"class"</tt><tt class="py-op">:</tt> <tt class="py-string">"row-fluid bottom-m"</tt><tt class="py-op">}</tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L158"></a><tt class="py-lineno">158</tt>  <tt class="py-line">            <tt class="py-name">sleep_html</tt> <tt class="py-op">=</tt> <tt class="py-name">tabs_html</tt><tt class="py-op">.</tt><tt class="py-name">find_all</tt><tt class="py-op">(</tt><tt class="py-string">"div"</tt><tt class="py-op">,</tt> <tt class="py-op">{</tt><tt class="py-string">"id"</tt><tt class="py-op">:</tt> <tt class="py-string">"pane5"</tt><tt class="py-op">}</tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L159"></a><tt class="py-lineno">159</tt>  <tt class="py-line">            <tt class="py-name">activities_html</tt> <tt class="py-op">=</tt> <tt class="py-name">tabs_html</tt><tt class="py-op">.</tt><tt class="py-name">find_all</tt><tt class="py-op">(</tt><tt class="py-string">"div"</tt><tt class="py-op">,</tt> <tt class="py-op">{</tt><tt class="py-string">"id"</tt><tt class="py-op">:</tt> <tt class="py-string">"pane4"</tt><tt class="py-op">}</tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L160"></a><tt class="py-lineno">160</tt>  <tt class="py-line">            <tt class="py-name">breakdown_html</tt> <tt class="py-op">=</tt> <tt class="py-name">tabs_html</tt><tt class="py-op">.</tt><tt class="py-name">find_all</tt><tt class="py-op">(</tt><tt class="py-string">"div"</tt><tt class="py-op">,</tt> <tt class="py-op">{</tt><tt class="py-string">"id"</tt><tt class="py-op">:</tt> <tt class="py-string">"pane2"</tt><tt class="py-op">}</tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L161"></a><tt class="py-lineno">161</tt>  <tt class="py-line"> </tt>
<a name="L162"></a><tt class="py-lineno">162</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt id="link-22" class="py-name"><a title="pygce.models.garmin.timeline.GCDayTimeline" class="py-name" href="#" onclick="return doclink('link-22', 'GCDayTimeline', 'link-2');">GCDayTimeline</a></tt><tt class="py-op">(</tt> </tt>
<a name="L163"></a><tt class="py-lineno">163</tt>  <tt class="py-line">                <tt class="py-name">date_time</tt><tt class="py-op">,</tt> </tt>
<a name="L164"></a><tt class="py-lineno">164</tt>  <tt class="py-line">                <tt class="py-name">summary_html</tt><tt class="py-op">,</tt> </tt>
<a name="L165"></a><tt class="py-lineno">165</tt>  <tt class="py-line">                <tt class="py-name">steps_html</tt><tt class="py-op">,</tt> </tt>
<a name="L166"></a><tt class="py-lineno">166</tt>  <tt class="py-line">                <tt class="py-name">sleep_html</tt><tt class="py-op">,</tt> </tt>
<a name="L167"></a><tt class="py-lineno">167</tt>  <tt class="py-line">                <tt class="py-name">activities_html</tt><tt class="py-op">,</tt> </tt>
<a name="L168"></a><tt class="py-lineno">168</tt>  <tt class="py-line">                <tt class="py-name">breakdown_html</tt> </tt>
<a name="L169"></a><tt class="py-lineno">169</tt>  <tt class="py-line">            <tt class="py-op">)</tt> </tt>
<a name="L170"></a><tt class="py-lineno">170</tt>  <tt class="py-line">        <tt class="py-keyword">except</tt> <tt class="py-name">Exception</tt> <tt class="py-keyword">as</tt> <tt class="py-name">e</tt><tt class="py-op">:</tt> </tt>
<a name="L171"></a><tt class="py-lineno">171</tt>  <tt class="py-line">            <tt class="py-keyword">print</tt><tt class="py-op">(</tt><tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">e</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L172"></a><tt class="py-lineno">172</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">None</tt> </tt>
</div><a name="L173"></a><tt class="py-lineno">173</tt>  <tt class="py-line"> </tt>
<a name="GarminConnectBot.get_days"></a><div id="GarminConnectBot.get_days-def"><a name="L174"></a><tt class="py-lineno">174</tt> <a class="py-toggle" href="#" id="GarminConnectBot.get_days-toggle" onclick="return toggle('GarminConnectBot.get_days');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pygce.models.bot.GarminConnectBot-class.html#get_days">get_days</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">min_date_time</tt><tt class="py-op">,</tt> <tt class="py-param">max_date_time</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="GarminConnectBot.get_days-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="GarminConnectBot.get_days-expanded"><a name="L175"></a><tt class="py-lineno">175</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L176"></a><tt class="py-lineno">176</tt>  <tt class="py-line"><tt class="py-docstring">        :param min_date_time: datetime</tt> </tt>
<a name="L177"></a><tt class="py-lineno">177</tt>  <tt class="py-line"><tt class="py-docstring">            Datetime object with date, this is the date when to start downloading data</tt> </tt>
<a name="L178"></a><tt class="py-lineno">178</tt>  <tt class="py-line"><tt class="py-docstring">        :param max_date_time: datetime</tt> </tt>
<a name="L179"></a><tt class="py-lineno">179</tt>  <tt class="py-line"><tt class="py-docstring">            Datetime object with date, this is the date when to stop downloading data</tt> </tt>
<a name="L180"></a><tt class="py-lineno">180</tt>  <tt class="py-line"><tt class="py-docstring">        :return: [] of GCDayTimline</tt> </tt>
<a name="L181"></a><tt class="py-lineno">181</tt>  <tt class="py-line"><tt class="py-docstring">            List of data about days</tt> </tt>
<a name="L182"></a><tt class="py-lineno">182</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L183"></a><tt class="py-lineno">183</tt>  <tt class="py-line"> </tt>
<a name="L184"></a><tt class="py-lineno">184</tt>  <tt class="py-line">        <tt class="py-name">days_delta</tt> <tt class="py-op">=</tt> <tt class="py-op">(</tt><tt class="py-name">max_date_time</tt> <tt class="py-op">-</tt> <tt class="py-name">min_date_time</tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">days</tt>  <tt class="py-comment"># days from begin to end</tt> </tt>
<a name="L185"></a><tt class="py-lineno">185</tt>  <tt class="py-line">        <tt class="py-name">days_data</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-op">]</tt>  <tt class="py-comment"># output list</tt> </tt>
<a name="L186"></a><tt class="py-lineno">186</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">i</tt> <tt class="py-keyword">in</tt> <tt class="py-name">range</tt><tt class="py-op">(</tt><tt class="py-name">days_delta</tt> <tt class="py-op">+</tt> <tt class="py-number">1</tt><tt class="py-op">)</tt><tt class="py-op">:</tt>  <tt class="py-comment"># including last day</tt> </tt>
<a name="L187"></a><tt class="py-lineno">187</tt>  <tt class="py-line">            <tt class="py-name">day_to_get</tt> <tt class="py-op">=</tt> <tt class="py-name">min_date_time</tt> <tt class="py-op">+</tt> <tt class="py-name">timedelta</tt><tt class="py-op">(</tt><tt class="py-name">days</tt><tt class="py-op">=</tt><tt class="py-name">i</tt><tt class="py-op">)</tt> </tt>
<a name="L188"></a><tt class="py-lineno">188</tt>  <tt class="py-line">            <tt class="py-keyword">print</tt><tt class="py-op">(</tt><tt class="py-string">"Getting day"</tt><tt class="py-op">,</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">day_to_get</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L189"></a><tt class="py-lineno">189</tt>  <tt class="py-line">            <tt class="py-name">days_data</tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-23" class="py-name" targets="Method pygce.models.bot.GarminConnectBot.get_day()=pygce.models.bot.GarminConnectBot-class.html#get_day"><a title="pygce.models.bot.GarminConnectBot.get_day" class="py-name" href="#" onclick="return doclink('link-23', 'get_day', 'link-23');">get_day</a></tt><tt class="py-op">(</tt><tt class="py-name">day_to_get</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L190"></a><tt class="py-lineno">190</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">days_data</tt> </tt>
</div><a name="L191"></a><tt class="py-lineno">191</tt>  <tt class="py-line"> </tt>
<a name="GarminConnectBot.save_json_days"></a><div id="GarminConnectBot.save_json_days-def"><a name="L192"></a><tt class="py-lineno">192</tt> <a class="py-toggle" href="#" id="GarminConnectBot.save_json_days-toggle" onclick="return toggle('GarminConnectBot.save_json_days');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pygce.models.bot.GarminConnectBot-class.html#save_json_days">save_json_days</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">min_date_time</tt><tt class="py-op">,</tt> <tt class="py-param">max_date_time</tt><tt class="py-op">,</tt> <tt class="py-param">output_file</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="GarminConnectBot.save_json_days-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="GarminConnectBot.save_json_days-expanded"><a name="L193"></a><tt class="py-lineno">193</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L194"></a><tt class="py-lineno">194</tt>  <tt class="py-line"><tt class="py-docstring">        :param min_date_time: datetime</tt> </tt>
<a name="L195"></a><tt class="py-lineno">195</tt>  <tt class="py-line"><tt class="py-docstring">            Datetime object with date, this is the date when to start downloading data</tt> </tt>
<a name="L196"></a><tt class="py-lineno">196</tt>  <tt class="py-line"><tt class="py-docstring">        :param max_date_time: datetime</tt> </tt>
<a name="L197"></a><tt class="py-lineno">197</tt>  <tt class="py-line"><tt class="py-docstring">            Datetime object with date, this is the date when to stop downloading data</tt> </tt>
<a name="L198"></a><tt class="py-lineno">198</tt>  <tt class="py-line"><tt class="py-docstring">        :param output_file: str</tt> </tt>
<a name="L199"></a><tt class="py-lineno">199</tt>  <tt class="py-line"><tt class="py-docstring">            Path where to save output to</tt> </tt>
<a name="L200"></a><tt class="py-lineno">200</tt>  <tt class="py-line"><tt class="py-docstring">        :return: void</tt> </tt>
<a name="L201"></a><tt class="py-lineno">201</tt>  <tt class="py-line"><tt class="py-docstring">            Retrieves data about days in given range, then saves json dump</tt> </tt>
<a name="L202"></a><tt class="py-lineno">202</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L203"></a><tt class="py-lineno">203</tt>  <tt class="py-line"> </tt>
<a name="L204"></a><tt class="py-lineno">204</tt>  <tt class="py-line">        <tt class="py-name">data</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-24" class="py-name" targets="Method pygce.models.bot.GarminConnectBot.get_days()=pygce.models.bot.GarminConnectBot-class.html#get_days"><a title="pygce.models.bot.GarminConnectBot.get_days" class="py-name" href="#" onclick="return doclink('link-24', 'get_days', 'link-24');">get_days</a></tt><tt class="py-op">(</tt><tt class="py-name">min_date_time</tt><tt class="py-op">,</tt> <tt class="py-name">max_date_time</tt><tt class="py-op">)</tt>  <tt class="py-comment"># get raw data</tt> </tt>
<a name="L205"></a><tt class="py-lineno">205</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">d</tt> <tt class="py-keyword">in</tt> <tt class="py-name">data</tt><tt class="py-op">:</tt> </tt>
<a name="L206"></a><tt class="py-lineno">206</tt>  <tt class="py-line">            <tt class="py-keyword">print</tt><tt class="py-op">(</tt><tt class="py-string">"Parsing day"</tt><tt class="py-op">,</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">d</tt><tt class="py-op">.</tt><tt class="py-name">date</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L207"></a><tt class="py-lineno">207</tt>  <tt class="py-line">            <tt class="py-name">d</tt><tt class="py-op">.</tt><tt id="link-25" class="py-name" targets="Method pygce.models.garmin.timeline.GCDayActivities.parse()=pygce.models.garmin.timeline.GCDayActivities-class.html#parse,Method pygce.models.garmin.timeline.GCDayBreakdown.parse()=pygce.models.garmin.timeline.GCDayBreakdown-class.html#parse,Method pygce.models.garmin.timeline.GCDaySection.parse()=pygce.models.garmin.timeline.GCDaySection-class.html#parse,Method pygce.models.garmin.timeline.GCDaySleep.parse()=pygce.models.garmin.timeline.GCDaySleep-class.html#parse,Method pygce.models.garmin.timeline.GCDaySteps.parse()=pygce.models.garmin.timeline.GCDaySteps-class.html#parse,Method pygce.models.garmin.timeline.GCDaySummary.parse()=pygce.models.garmin.timeline.GCDaySummary-class.html#parse,Method pygce.models.garmin.timeline.GCDayTimeline.parse()=pygce.models.garmin.timeline.GCDayTimeline-class.html#parse"><a title="pygce.models.garmin.timeline.GCDayActivities.parse
pygce.models.garmin.timeline.GCDayBreakdown.parse
pygce.models.garmin.timeline.GCDaySection.parse
pygce.models.garmin.timeline.GCDaySleep.parse
pygce.models.garmin.timeline.GCDaySteps.parse
pygce.models.garmin.timeline.GCDaySummary.parse
pygce.models.garmin.timeline.GCDayTimeline.parse" class="py-name" href="#" onclick="return doclink('link-25', 'parse', 'link-25');">parse</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt>  <tt class="py-comment"># parse</tt> </tt>
<a name="L208"></a><tt class="py-lineno">208</tt>  <tt class="py-line">        <tt class="py-name">json_data</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-name">json</tt><tt class="py-op">.</tt><tt class="py-name">loads</tt><tt class="py-op">(</tt><tt class="py-name">d</tt><tt class="py-op">.</tt><tt id="link-26" class="py-name" targets="Method pygce.models.garmin.timeline.GCDayActivities.to_json()=pygce.models.garmin.timeline.GCDayActivities-class.html#to_json,Method pygce.models.garmin.timeline.GCDaySection.to_json()=pygce.models.garmin.timeline.GCDaySection-class.html#to_json,Method pygce.models.garmin.timeline.GCDayTimeline.to_json()=pygce.models.garmin.timeline.GCDayTimeline-class.html#to_json"><a title="pygce.models.garmin.timeline.GCDayActivities.to_json
pygce.models.garmin.timeline.GCDaySection.to_json
pygce.models.garmin.timeline.GCDayTimeline.to_json" class="py-name" href="#" onclick="return doclink('link-26', 'to_json', 'link-26');">to_json</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> <tt class="py-keyword">for</tt> <tt class="py-name">d</tt> <tt class="py-keyword">in</tt> <tt class="py-name">data</tt><tt class="py-op">]</tt>  <tt class="py-comment"># convert to json objects</tt> </tt>
<a name="L209"></a><tt class="py-lineno">209</tt>  <tt class="py-line">        <tt class="py-keyword">with</tt> <tt class="py-name">open</tt><tt class="py-op">(</tt><tt class="py-name">output_file</tt><tt class="py-op">,</tt> <tt class="py-string">"w"</tt><tt class="py-op">)</tt> <tt class="py-keyword">as</tt> <tt class="py-name">o</tt><tt class="py-op">:</tt>  <tt class="py-comment"># write to file</tt> </tt>
<a name="L210"></a><tt class="py-lineno">210</tt>  <tt class="py-line">            <tt class="py-name">json</tt><tt class="py-op">.</tt><tt class="py-name">dump</tt><tt class="py-op">(</tt><tt class="py-name">json_data</tt><tt class="py-op">,</tt> <tt class="py-name">o</tt><tt class="py-op">)</tt> </tt>
</div><a name="L211"></a><tt class="py-lineno">211</tt>  <tt class="py-line"> </tt>
<a name="GarminConnectBot.save_csv_days"></a><div id="GarminConnectBot.save_csv_days-def"><a name="L212"></a><tt class="py-lineno">212</tt> <a class="py-toggle" href="#" id="GarminConnectBot.save_csv_days-toggle" onclick="return toggle('GarminConnectBot.save_csv_days');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pygce.models.bot.GarminConnectBot-class.html#save_csv_days">save_csv_days</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">min_date_time</tt><tt class="py-op">,</tt> <tt class="py-param">max_date_time</tt><tt class="py-op">,</tt> <tt class="py-param">output_file</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="GarminConnectBot.save_csv_days-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="GarminConnectBot.save_csv_days-expanded"><a name="L213"></a><tt class="py-lineno">213</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L214"></a><tt class="py-lineno">214</tt>  <tt class="py-line"><tt class="py-docstring">        :param min_date_time: datetime</tt> </tt>
<a name="L215"></a><tt class="py-lineno">215</tt>  <tt class="py-line"><tt class="py-docstring">            Datetime object with date, this is the date when to start downloading data</tt> </tt>
<a name="L216"></a><tt class="py-lineno">216</tt>  <tt class="py-line"><tt class="py-docstring">        :param max_date_time: datetime</tt> </tt>
<a name="L217"></a><tt class="py-lineno">217</tt>  <tt class="py-line"><tt class="py-docstring">            Datetime object with date, this is the date when to stop downloading data</tt> </tt>
<a name="L218"></a><tt class="py-lineno">218</tt>  <tt class="py-line"><tt class="py-docstring">        :param output_file: str</tt> </tt>
<a name="L219"></a><tt class="py-lineno">219</tt>  <tt class="py-line"><tt class="py-docstring">            Path where to save output to</tt> </tt>
<a name="L220"></a><tt class="py-lineno">220</tt>  <tt class="py-line"><tt class="py-docstring">        :return: void</tt> </tt>
<a name="L221"></a><tt class="py-lineno">221</tt>  <tt class="py-line"><tt class="py-docstring">            Retrieves data about days in given range, then saves csv dump</tt> </tt>
<a name="L222"></a><tt class="py-lineno">222</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L223"></a><tt class="py-lineno">223</tt>  <tt class="py-line"> </tt>
<a name="L224"></a><tt class="py-lineno">224</tt>  <tt class="py-line">        <tt class="py-name">data</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-27" class="py-name"><a title="pygce.models.bot.GarminConnectBot.get_days" class="py-name" href="#" onclick="return doclink('link-27', 'get_days', 'link-24');">get_days</a></tt><tt class="py-op">(</tt><tt class="py-name">min_date_time</tt><tt class="py-op">,</tt> <tt class="py-name">max_date_time</tt><tt class="py-op">)</tt>  <tt class="py-comment"># get raw data</tt> </tt>
<a name="L225"></a><tt class="py-lineno">225</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">d</tt> <tt class="py-keyword">in</tt> <tt class="py-name">data</tt><tt class="py-op">:</tt> </tt>
<a name="L226"></a><tt class="py-lineno">226</tt>  <tt class="py-line">            <tt class="py-keyword">print</tt><tt class="py-op">(</tt><tt class="py-string">"Parsing day"</tt><tt class="py-op">,</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">d</tt><tt class="py-op">.</tt><tt class="py-name">date</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L227"></a><tt class="py-lineno">227</tt>  <tt class="py-line">            <tt class="py-name">d</tt><tt class="py-op">.</tt><tt id="link-28" class="py-name"><a title="pygce.models.garmin.timeline.GCDayActivities.parse
pygce.models.garmin.timeline.GCDayBreakdown.parse
pygce.models.garmin.timeline.GCDaySection.parse
pygce.models.garmin.timeline.GCDaySleep.parse
pygce.models.garmin.timeline.GCDaySteps.parse
pygce.models.garmin.timeline.GCDaySummary.parse
pygce.models.garmin.timeline.GCDayTimeline.parse" class="py-name" href="#" onclick="return doclink('link-28', 'parse', 'link-25');">parse</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt>  <tt class="py-comment"># parse</tt> </tt>
<a name="L228"></a><tt class="py-lineno">228</tt>  <tt class="py-line"> </tt>
<a name="L229"></a><tt class="py-lineno">229</tt>  <tt class="py-line">        <tt class="py-name">data</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-name">d</tt><tt class="py-op">.</tt><tt id="link-29" class="py-name" targets="Method pygce.models.garmin.timeline.GCDayActivities.to_csv_dict()=pygce.models.garmin.timeline.GCDayActivities-class.html#to_csv_dict,Method pygce.models.garmin.timeline.GCDaySection.to_csv_dict()=pygce.models.garmin.timeline.GCDaySection-class.html#to_csv_dict,Method pygce.models.garmin.timeline.GCDayTimeline.to_csv_dict()=pygce.models.garmin.timeline.GCDayTimeline-class.html#to_csv_dict"><a title="pygce.models.garmin.timeline.GCDayActivities.to_csv_dict
pygce.models.garmin.timeline.GCDaySection.to_csv_dict
pygce.models.garmin.timeline.GCDayTimeline.to_csv_dict" class="py-name" href="#" onclick="return doclink('link-29', 'to_csv_dict', 'link-29');">to_csv_dict</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> <tt class="py-keyword">for</tt> <tt class="py-name">d</tt> <tt class="py-keyword">in</tt> <tt class="py-name">data</tt><tt class="py-op">]</tt>  <tt class="py-comment"># get csv</tt> </tt>
<a name="L230"></a><tt class="py-lineno">230</tt>  <tt class="py-line">        <tt class="py-name">csv_headers</tt> <tt class="py-op">=</tt> <tt class="py-name">data</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt><tt class="py-op">.</tt><tt class="py-name">keys</tt><tt class="py-op">(</tt><tt class="py-op">)</tt>  <tt class="py-comment"># get headers for a sample dict</tt> </tt>
<a name="L231"></a><tt class="py-lineno">231</tt>  <tt class="py-line">        <tt class="py-keyword">with</tt> <tt class="py-name">open</tt><tt class="py-op">(</tt><tt class="py-name">output_file</tt><tt class="py-op">,</tt> <tt class="py-string">"w"</tt><tt class="py-op">)</tt> <tt class="py-keyword">as</tt> <tt class="py-name">o</tt><tt class="py-op">:</tt>  <tt class="py-comment"># write to file</tt> </tt>
<a name="L232"></a><tt class="py-lineno">232</tt>  <tt class="py-line">            <tt class="py-name">dict_writer</tt> <tt class="py-op">=</tt> <tt class="py-name">csv</tt><tt class="py-op">.</tt><tt class="py-name">DictWriter</tt><tt class="py-op">(</tt><tt class="py-name">o</tt><tt class="py-op">,</tt> <tt class="py-name">csv_headers</tt><tt class="py-op">)</tt> </tt>
<a name="L233"></a><tt class="py-lineno">233</tt>  <tt class="py-line">            <tt class="py-name">dict_writer</tt><tt class="py-op">.</tt><tt class="py-name">writeheader</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L234"></a><tt class="py-lineno">234</tt>  <tt class="py-line">            <tt class="py-name">dict_writer</tt><tt class="py-op">.</tt><tt class="py-name">writerows</tt><tt class="py-op">(</tt><tt class="py-name">data</tt><tt class="py-op">)</tt> </tt>
</div></div><a name="L235"></a><tt class="py-lineno">235</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a href="https://github.com/sirfoga/pygce">PyGCE</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Mon Apr 17 18:39:16 2017
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
